"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _ButtonRow = _interopRequireDefault(require("../ButtonRow"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DockedFooter =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DockedFooter, _React$Component);

  function DockedFooter(props) {
    var _this;

    _classCallCheck(this, DockedFooter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DockedFooter).call(this, props));
    _this.state = {
      isDocked: true,
      listenersSet: false,
      dockedFooterNode: null,
      parentNode: null,
      atBottom: true,
      shouldDockByHeight: true
    };
    _this.dockedFooterRef = _react["default"].createRef();
    _this.storeThisNode = _this.storeThisNode.bind(_assertThisInitialized(_this));
    _this.domNodesInState = _this.domNodesInState.bind(_assertThisInitialized(_this));
    _this.setShouldDockByHeight = _this.setShouldDockByHeight.bind(_assertThisInitialized(_this));
    _this.setAtBottom = _this.setAtBottom.bind(_assertThisInitialized(_this));
    _this.setEventListeners = _this.setEventListeners.bind(_assertThisInitialized(_this));
    _this.throttle = _this.throttle.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DockedFooter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.storeThisNode();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.scrollRef !== prevProps.scrollRef) {
        this.setState({
          parentNode: this.props.scrollRef
        });
      }

      if (this.state.parentNode !== prevState.parentNode) {
        this.setShouldDockByHeight();
        this.setAtBottom();
      }

      if (this.state.shouldDockByHeight !== prevState.shouldDockByHeight) {
        this.setState({
          isDocked: this.state.shouldDockByHeight
        });
      }

      if (this.state.atBottom !== prevState.atBottom) {
        this.setState({
          isDocked: !this.state.atBottom
        });
      }

      this.setEventListeners();
    }
  }, {
    key: "storeThisNode",
    value: function storeThisNode() {
      if (this.dockedFooterRef.current !== null) {
        this.setState({
          dockedFooterNode: this.dockedFooterRef.current
        });
      }
    }
  }, {
    key: "domNodesInState",
    value: function domNodesInState() {
      return !!this.state.dockedFooterNode && !!this.state.parentNode;
    }
  }, {
    key: "setEventListeners",
    value: function setEventListeners() {
      if (!this.state.listenersSet && this.domNodesInState()) {
        var scrollContainer = this.state.parentNode;
        window.addEventListener('resize', this.throttle(3, this.setShouldDockByHeight), {
          passive: false
        }, {
          useCapture: true
        });
        window.addEventListener('mousemove', this.throttle(3, this.setShouldDockByHeight), {
          passive: false
        }, {
          useCapture: true
        });
        scrollContainer.addEventListener('scroll', this.throttle(3, this.setAtBottom), {
          passive: true
        });
        scrollContainer.addEventListener('wheel', this.throttle(3, this.setAtBottom), {
          passive: true
        });
        scrollContainer.addEventListener('click', this.setShouldDockByHeight, {
          passive: true
        });
        scrollContainer.addEventListener('keydown', this.setShouldDockByHeight, {
          passive: true
        });
        this.setState({
          listenersSet: true
        });
      }
    }
  }, {
    key: "throttle",
    value: function throttle(delay, fn) {
      var lastCall = 0;
      return function () {
        var now = new Date().getTime();

        if (now - lastCall < delay) {
          return;
        }

        lastCall = now;
        return fn.apply(void 0, arguments);
      };
    }
  }, {
    key: "setShouldDockByHeight",
    value: function setShouldDockByHeight() {
      if (this.domNodesInState()) {
        var newState = {
          shouldDockByHeight: this.state.dockedFooterNode.offsetTop >= this.state.parentNode.offsetHeight - this.state.dockedFooterNode.offsetHeight
        };
        this.setState(newState);
      }

      this.setAtBottom();
    }
  }, {
    key: "setAtBottom",
    value: function setAtBottom() {
      if (this.domNodesInState()) {
        var newState = {
          atBottom: this.state.parentNode.scrollHeight - this.state.parentNode.scrollTop === this.state.parentNode.clientHeight
        };
        this.setState(newState);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.throttle(3, this.shouldDock));
      window.removeEventListener('mousemove', this.throttle(5, this.setShouldDockByHeight), {
        passive: false
      }, {
        useCapture: true
      });
      this.state.parentNode.removeEventListener('scroll', this.throttle(3, this.setAtBottom), {
        passive: true
      });
      this.state.parentNode.removeEventListener('wheel', this.throttle(3, this.setAtBottom), {
        passive: true
      });
      this.state.parentNode.removeEventListener('click', this.shouldDock, {
        passive: true
      });
      this.state.parentNode.removeEventListener('keydown', this.shouldDock, {
        passive: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        "data-test-section": this.props.testSection,
        ref: this.dockedFooterRef,
        className: (0, _classnames["default"])({
          'oui-docked-footer': true,
          'oui-docked-footer--is-docked': this.state.isDocked,
          'push-double--top': this.props.includesMargin
        })
      }, _react["default"].createElement(_ButtonRow["default"], {
        leftGroup: this.props.leftGroup,
        centerGroup: this.props.centerGroup,
        rightGroup: this.props.rightGroup,
        testSection: this.props.testSection
      }));
    }
  }]);

  return DockedFooter;
}(_react["default"].Component);

DockedFooter.propTypes = {
  /**
   *  Any components to be included in the DockedFooter
   */
  centerGroup: _propTypes["default"].arrayOf(_propTypes["default"].element),

  /**
   *  Used to determine if there should be top margin
   */
  includesMargin: _propTypes["default"].bool,

  /**
   * Array of buttons for left side
   */
  leftGroup: _propTypes["default"].arrayOf(_propTypes["default"].element),

  /**
   * Array of buttons for right side
   */
  rightGroup: _propTypes["default"].arrayOf(_propTypes["default"].element),

  /**
   * Ref from parent element for DockedFooter to set listeners
   */
  scrollRef: _propTypes["default"].node,

  /**
   * Identifier used to create data-test-section attributes for testing.
   */
  testSection: _propTypes["default"].string.isRequired
};
DockedFooter.defaultProps = {
  scrollRef: null,
  includesMargin: false,
  testSection: ''
};
var _default = DockedFooter;
exports["default"] = _default;