"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var DraggableItem = function DraggableItem(_ref) {
  var id = _ref.id,
      index = _ref.index,
      item = _ref.item,
      renderFunc = _ref.renderFunc,
      useCustomDragHandle = _ref.useCustomDragHandle;
  return _react["default"].createElement(_reactBeautifulDnd.Draggable, {
    key: item.id,
    draggableId: id.toString(),
    index: index
  }, function (provided, snapshot) {
    return _react["default"].createElement("li", _extends({
      className: "oui-sortable__item flex",
      ref: provided.innerRef
    }, provided.draggableProps, useCustomDragHandle ? {} : provided.dragHandleProps), renderFunc({
      item: item,
      index: index,
      snapshot: snapshot,
      dragHandleProps: provided.dragHandleProps
    }));
  });
};

DraggableItem.propTypes = {
  /**
   * Id for this particular Draggable Item
   */
  id: _propTypes["default"].number.isRequired,

  /**
   * Current index for this particular Draggable Item
   */
  index: _propTypes["default"].number.isRequired,

  /**
   * Item to render using render function pass as prop
   */
  item: _propTypes["default"].shape({
    id: _propTypes["default"].number
  }).isRequired,

  /**
   * Function used to render the contents of this Draggable Item
   */
  renderFunc: _propTypes["default"].func.isRequired,

  /**
   * Whether or not the item itself will make use of the drag handle
   */
  useCustomDragHandle: _propTypes["default"].bool
};
var _default = DraggableItem;
exports["default"] = _default;