"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Container = _react["default"].forwardRef(function (_ref, ref) {
  var _ref$as = _ref.as,
      Component = _ref$as === void 0 ? 'div' : _ref$as,
      fluid = _ref.fluid,
      isFullHeight = _ref.isFullHeight,
      outlineDebug = _ref.outlineDebug,
      paddedContent = _ref.paddedContent,
      pullRowPadding = _ref.pullRowPadding,
      pushRowsTop = _ref.pushRowsTop,
      props = _objectWithoutProperties(_ref, ["as", "fluid", "isFullHeight", "outlineDebug", "paddedContent", "pullRowPadding", "pushRowsTop"]);

  var prefix = 'container';
  return _react["default"].createElement(Component, _extends({
    ref: ref
  }, props, {
    className: (0, _classnames["default"])(fluid ? "".concat(prefix, "-fluid") : prefix, isFullHeight && 'height--1-1', outlineDebug && 'outline--debug', paddedContent && "padded-content--".concat(paddedContent), pullRowPadding && 'container--pull', pushRowsTop && 'push-rows--top')
  }));
});

Container.propTypes = {
  as: _propTypes["default"].any,
  fluid: _propTypes["default"].bool,
  isFullHeight: _propTypes["default"].bool,
  outlineDebug: _propTypes["default"].bool,
  paddedContent: _propTypes["default"].oneOf(['none', 'around', 'sides', 'ends', 'remove']),
  pullRowPadding: _propTypes["default"].bool,
  pushRowsTop: _propTypes["default"].bool
};
Container.displayName = 'Container';
Container.defaultProps = {
  fluid: false,
  isFullHeight: false
};
var _default = Container;
exports["default"] = _default;